#include "LaTeX_Messpunkteingabe_GUI.h"
#include <qdebug.h>

// Einstellungsdaten Struktur
LaTeX_Messpunkteingabe_GUI::Settings_Data user_settings;

double measurements[MAX_MEASUREMENTS][2] = { 0 };	// Array zur Abspeicherung der Daten


// Hauptobjekt (Fenster)
LaTeX_Messpunkteingabe_GUI::LaTeX_Messpunkteingabe_GUI(QWidget *parent)
	: QMainWindow(parent)
{
	ui.setupUi(this);
	setCentralWidget(uip->centralWidget);

	// Damit Fenstergre nicht verndert werden kann (und auch nicht maximiert)
	setFixedSize(width(), height());
	
	// Knpfe an Funktionen binden
	connect(uip->pushButton_refresh, SIGNAL(released()), this, SLOT(on_pushbutton_refresh_released()));
	connect(uip->pushButton_markAndCopy, SIGNAL(released()), this, SLOT(on_pushbutton_markAndCopy_released()));
	connect(uip->pushButton_settings, SIGNAL(released()), this, SLOT(on_pushbutton_settings_released()));
	connect(uip->pushButton_help, SIGNAL(released()), this, SLOT(on_pushbutton_help_released()));
	connect(uip->pushButton_data_load, SIGNAL(released()), this, SLOT(on_pushbutton_data_load_released()));
	connect(uip->pushButton_data_save, SIGNAL(released()), this, SLOT(on_pushbutton_data_save_released()));

	int i = 0;


	// ZUM TESTEN DER LATEX- FUNKTION
	while (i < 3)
	{
		measurements[i][0] = 3;
		measurements[i][1] = 1;
		i++;
	};

	// Merke: Das Array muss immer Lckenlos gefllt sein, damit getCountNumber() nicht rumspinnt und das richtige Ergebnis ausgibt
	measurements[3][0] = 7;
	measurements[3][1] = 100.1325;

	//QWidget *settings_window = new QWidget();
	//settings_window->show();

}


//--< Knopffunktionen >---------------------------------------------------------------------------------------------------------->>>>>

// Button released: Refresh
void LaTeX_Messpunkteingabe_GUI::on_pushbutton_refresh_released()
{
	qDebug() << "on_pushbutton_refresh_released";

	create_latex_code(user_settings, measurements);



}

// Button released: Mark everything and copy to clipboard
void LaTeX_Messpunkteingabe_GUI::on_pushbutton_markAndCopy_released()
{
	qDebug() << "on_pushbutton_markAndCopy_released";

	select_and_copy_content();


}

// Button released: Display settings
void LaTeX_Messpunkteingabe_GUI::on_pushbutton_settings_released()
{
	qDebug() << "on_pushbutton_settings_released";

	uip->latex_code_display->setText("Einstellungen geoeffnet.");

	settings_window set_wind;
	set_wind.setModal(true);
	set_wind.exec();

}

// Button released: Display help
void LaTeX_Messpunkteingabe_GUI::on_pushbutton_help_released()
{
	qDebug() << "on_pushbutton_help_released";

	uip->latex_code_display->setText("Hilfe anzeigen.");

}

// Button released: Load Data
void LaTeX_Messpunkteingabe_GUI::on_pushbutton_data_load_released()
{
	qDebug() << "on_pushbutton_data_load_released";

	uip->latex_code_display->setText("Daten geladen.");


}

// Button released: Save Data
void LaTeX_Messpunkteingabe_GUI::on_pushbutton_data_save_released()
{
	qDebug() << "on_pushbutton_data_save_released";

	uip->latex_code_display->setText("Daten gespeichert.");

}

int LaTeX_Messpunkteingabe_GUI::getCountNumb(double measurements[MAX_MEASUREMENTS][2])
{
	int numb = 0;	// 1 weil der erste Datenpunkt mglicherweise "0", also der "Ursprung", ist

	if (measurements[0][0] == 0)
	{
		return numb = 0;
	}

	else
	{
		for (int i = 0; i < MAX_MEASUREMENTS; i++)
		{
			if (measurements[i][0] == 0)
			{
				numb = i;
				break;
			}
		}
	}

	return numb;
}


// HIER WEITERBEARBEITEN WIE MACHEN TUN KANAAA?
//std::string double_to_string(double value)
//{
//	char value_array[1000] = { 0 };
//	doublee max_deci = 0;
//
//	// Puffer fr die Dekadenzahlen
//	int deci_buffer[16] = { 0 };
//
//	// Check, welche die grte vorhandene Dekade ist
//	if (value == 0)
//	{
//		return 0;
//	}
//	else if (value >= 100000000.0)
//	{
//		max_deci = 8;
//	}
//	else if (value >= 10000000.0)
//	{
//		max_deci = 7;
//	}
//	else if (value >= 1000000.0)
//	{
//		max_deci = 6;
//	}
//	else if (value >= 100000.0)
//	{
//		max_deci = 5;
//	}
//	else if (value >= 10000.0)
//	{
//		max_deci = 4;
//	}
//	else if (value >= 1000.0)
//	{
//		max_deci = 3;
//	}
//	else if (value >= 100.0)
//	{
//		max_deci = 2;
//	}
//	else if (value >= 10.0)
//	{
//		max_deci = 1;
//	}
//	else if (value < 0.1)
//	{
//		max_deci = -1;
//	}
//	else if (value < 0.01)
//	{
//		max_deci = -2;
//	}
//	else if (value < 0.001)
//	{
//		max_deci = -3;
//	}
//	else if (value < 0.0001)
//	{
//		max_deci = -4;
//	}
//	else if (value < 0.00001)
//	{
//		max_deci = -5;
//	}
//	
//
//	for (int i = max_deci; i > 0; i--)
//	{
//		deci_buffer[i] = value / i;
//	}
//
//
//
//
//}

//--< Widget- Verarbeitungs- Funktionen >---------------------------------------------------------------------------------------->>>>>

void LaTeX_Messpunkteingabe_GUI::create_latex_code(Settings_Data p_user_settings, double pmeasurements[MAX_MEASUREMENTS][2])
{
	std::string latex_code;	// String fr LaTeX- Code zum Ausgeben und Erstellen
	
	std::ostringstream double_convert_buffer_1;	// ostringstream ist eine Klasse zum verarbeiten von Strings -> Wird hier bentigt um einen Puffer zum Konvertieren auf "normale" Strings bereitzustellen
	std::ostringstream double_convert_buffer_2;
	
	QString output_string;	// Auszugebender String

	int measureCount = 0;	// Anzahl der Datenpunkte

	// Anzahl der Datenpunkte ermitteln
	measureCount = getCountNumb(pmeasurements);


	//---------------------- LaTeX- Code erstellen ------------------------------>>>>>

	// Tabellengrundgerst
	latex_code = "\\begin{table}[H]\n";
	latex_code += "\t\\begin{tabular}{|l|l|}\\hline\n";

	// berschriften bzw. Bezeichnungen in den Spalten
	latex_code += "\t\t\\textbf{";
	latex_code += p_user_settings.get_label1_text();
	latex_code += "}&\\textbf{";
	latex_code += p_user_settings.get_label2_text();
	latex_code += "} \\\\ \\hline \\hline\n";

	// Daten fr die Tabelle ausgeben
	for (int i = 0; i < measureCount; i++)
	{
		// Konvertierung: Double zu String
		double_convert_buffer_1 << pmeasurements[i][0];
		double_convert_buffer_2 << pmeasurements[i][1];

		// Muss hier neu angelegt werden, da die Deklaration des Strings mittels Konstruktor string("Inhalt") erfolgt, aber so nicht berschrieben werden kann
		std::string double_buffer_out_1(double_convert_buffer_1.str());
		std::string double_buffer_out_2(double_convert_buffer_2.str());

		// Wert 1
		latex_code += ("\t\t\t");
		latex_code += "$";
		latex_code += double_buffer_out_1;
		latex_code += "$";

		// Wert 2
		latex_code += " & ";
		latex_code += "$";
		latex_code += double_buffer_out_2;
		latex_code += "$";
		latex_code += "\\\\ \\hline \n";
		
		
		// Strings resetten
		double_convert_buffer_1.str("");	// ostringstream -> Muss entsprechende Methode der Klasse ostringstream aufgerufen werden
		double_convert_buffer_2.str("");	// " - - "
		double_convert_buffer_1.clear();	// Die Methode clear() wird bentigt, um eventuelle Fehlerflags, die gesetzt wurden, zurckzusetzen/ zu erntfernen
		double_convert_buffer_2.clear();	// " - - "
		
		double_buffer_out_1 = "";			// Normales Zurcksetzen eines Strings
		double_buffer_out_2 = "";			// " - - "

	}

		/*if (p_user_settings.decpts_status == decpts_both)
		{
			for (int i = 0; i < measureCount; i++)
			{
				fprintf(file_latex_pt, "\t$ %.*lf $ \t & \t $ %.*lf $ \\\\ \\hline \n", p_user_settings.decpts_nb, measurements[i][0], p_user_settings.decpts_nb, measurements[i][1]);
			}
		}

		if (p_user_settings.decpts_status == decpts_none)
		{
			for (int i = 0; i < measureCount; i++)
			{
				fprintf(file_latex_pt, "\t$ %.*lf $ \t & \t $ %.*lf $ \\\\ \\hline \n", 0, measurements[i][0], 0, measurements[i][1]);
			}
		}

		if (p_user_settings.decpts_status == decpts_dataval_only)
		{
			for (int i = 0; i < measureCount; i++)
			{
				fprintf(file_latex_pt, "\t$ %.*lf $ \t & \t $ %.*lf $ \\\\ \\hline \n", 0, measurements[i][0], p_user_settings.decpts_nb, measurements[i][1]);
			}
		}

		if (p_user_settings.decpts_status == decpts_datapts_only)
		{
			for (int i = 0; i < measureCount; i++)
			{
				fprintf(file_latex_pt, "\t$ %.*lf $ \t & \t $ %.*lf $ \\\\ \\hline \n", p_user_settings.decpts_nb, measurements[i][0], 0, measurements[i][1]);
			}
		}*/

	//	////ORIGINAL AUSGABE LATEX- CODE WERTE/PUNKTE
	//	//for (int i = 0; i < measureCount; i++)
	//	//{
	//	//	fprintf(file_latex_pt, "\t$ %.*lf $ \t & \t $ %.*lf $ \\\\ \\hline \n", decpts, measurements[i][0], decpts, measurements[i][1]);
	//	//}
	//}


	// Ende der Tabelle
	latex_code += "\t\\end{tabular}\n";

	// Optionale Bezeichnung der Tabelle
	if (p_user_settings.get_has_label())
	{
		latex_code += "\\caption{";
		latex_code += p_user_settings.get_label_tabular_text();
		latex_code += "}\n";
	}

	// Ende des Tabellenkonstrukts
	latex_code += "\\end{table}\n";

	// Code in QString umwandeln (weil sonst die Qt- Forms nicht funktionieren und nichts ausgegeben wird und so)
	output_string = QString::fromStdString(latex_code);

	// Code ausgeben
	uip->latex_code_display->setText(output_string);


	//// Bezeichnung der Tabellenstruktur
	//if (p_user_settings.has_label)
	//{
	//	fprintf(file_latex_pt, "\\caption{");
	//	fputs(p_user_settings.label_tabular, file_latex_pt);
	//	fprintf(file_latex_pt, "}\n");
	//}
	//fprintf(file_latex_pt, "\\end{table");
	//fprintf(file_latex_pt, "}\n");


}

void LaTeX_Messpunkteingabe_GUI::select_and_copy_content()
{
	QString output_string;	// String zum Speichern auf dem Clipboard

	// Neue Instanz von QClipboard erstellen
	QClipboard *gui_clpboard = QApplication::clipboard();

	// Den ganzen Text im LaTeX- Code- Display markieren
	uip->latex_code_display->selectAll();

	// Den ganzen Text in einen String laden
	output_string = uip->latex_code_display->toPlainText();
	
	// Text aus dem String ins Clipboard laden
	gui_clpboard->setText(output_string);

}
