/********************************************************************
Autor/en		:	T. Vandrey
Datum			:
Version			:	1
Datei			:	latex_eingabe_header.h
Dateifunktion	:	Prototypen, Symb. Konstanten, etc. vordefiniert

Kurzbeschreibung:
n.A.
********************************************************************/
#pragma once

#include "LaTeX_Messpunkteingabe_MainHeader.h"

//===[ Strukturen & Klassen ]===================================================================================================================

class LaTeX_Messpunkteingabe_GUI : public QMainWindow
{
	Q_OBJECT

public:
	LaTeX_Messpunkteingabe_GUI(QWidget *parent = Q_NULLPTR);

	// Klasse fr Datenpaare
	struct paireddata
	{
		double data_point;
		double data_value;
	};

	// Klasse fr Daten
	class Settings_Data
	{
		// Datenstze ------------------------------------->
	private:
		int decpts_nb;					// Dezimalstellen nach dem Komma
		int decpts_status;				// Dezimalstellenanzeige

		int column_nb;					// Anzahl der Spaltenpaare
		int column_lim;					// Grenze der Reihen, bis wohin ein Spaltenpaar gehen soll

		bool has_label;					// Ob die LaTeX- Tabelle eine Bezeichnung hat

		// LaTeX- Bezeichnungen und Namen
		std::string label1;					// Label linke Spalte
		std::string label2;					// Label rechte Spalte
		std::string label_tabular;			// Label der gesamten Tabelle


		// Getter & Setter & Constructer -------------------------------->
	public:

		// Konstruktor
		Settings_Data() {};

		// Konstruktor 2
		Settings_Data(int pdecpts_nb, int pdecpts_status, int pcolumn_nb, int pcolumn_lim, bool phas_label, std::string plabel1, std::string plabel2, std::string plabel_tabular)
		{
			decpts_nb = pdecpts_nb;
			decpts_status = pdecpts_status;

			column_nb = pcolumn_nb;
			column_lim = pcolumn_lim;

			has_label = phas_label;

			label1 = plabel1;

			label2 = plabel2;

			label_tabular = plabel_tabular;
		}

		// Destruktor
		~Settings_Data() {};


		// Setter/Getter: decpts_nb
		void set_decpts_nb(int pDecpts_nb)
		{
			decpts_nb = pDecpts_nb;
			return;
		}
		int get_decpts_nb(void)
		{
			return decpts_nb;
		}

		// Setter/Getter: decpts_status
		void set_decpts_status(int pDecpts_status)
		{
			decpts_status = pDecpts_status;
			return;
		}
		int get_decpts_status(void)
		{
			return decpts_status;
		}

		// Setter/Getter: column_nb
		void set_column_nb(int pColumn_nb)
		{
			column_nb = pColumn_nb;
			return;
		}
		int get_column_nb(void)
		{
			return column_nb;
		}

		// Setter/Getter: column_lim
		void set_column_lim(int pColumn_lim)
		{
			column_lim = pColumn_lim;
			return;
		}
		int get_column_lim(void)
		{
			return column_lim;
		}

		// Setter/Getter has_label
		void set_has_label(bool pHas_label)
		{
			has_label = pHas_label;
			return;
		}
		bool get_has_label(void)
		{
			return has_label;
		}

		// Setter/Getter label1, label2, label_tabular
		void set_label1_text(std::string pString)
		{
			label1 = pString;
			return;
		}
		void set_label2_text(std::string pString)
		{
			label2 = pString;
			return;
		}
		void set_label_tabular_text(std::string pString)
		{
			label_tabular = pString;
			return;
		}

		std::string get_label1_text(void)
		{
			return label1;
		}
		std::string get_label2_text(void)
		{
			return label2;
		}
		std::string get_label_tabular_text(void)
		{
			return label_tabular;
		}

	};


private:
	Ui::LaTeX_Messpunkteingabe_GUIClass ui;
	Ui::LaTeX_Messpunkteingabe_GUIClass* uip = &ui;

	// Eigene Funktionen
	void create_latex_code(LaTeX_Messpunkteingabe_GUI::Settings_Data p_user_settings, double pmeasurements[MAX_MEASUREMENTS][2]);
	int getCountNumb(double measurements[MAX_MEASUREMENTS][2]);
	void select_and_copy_content();


	// Slots fr Buttons
private slots:
	void on_pushbutton_refresh_released();
	void on_pushbutton_markAndCopy_released();
	void on_pushbutton_settings_released();
	void on_pushbutton_help_released();
	void on_pushbutton_data_load_released();
	void on_pushbutton_data_save_released();
};

